!=========================================================================
! Copyright (C) GemTalk Systems 1986-2016.  All Rights Reserved.
!
! $Id: clusterimage.gs,v 1.7 2008-01-09 19:02:30 stever Exp $
!
!=========================================================================

expectvalue %Boolean
run
Globals rebuildIfNeeded
%

run
System clusterAllSymbols .
^ true
%

expectvalue false
run
| classes nonClasses behaviorBucket descriptionBucket otherBucket |
behaviorBucket := AllClusterBuckets at: 4 .
descriptionBucket := AllClusterBuckets at: 5 .
otherBucket := AllClusterBuckets at: 6  .

classes := Globals select:[:i| i isKindOf: Behavior ] .
nonClasses := Globals reject:[:i| i isKindOf: Behavior ] .
nonClasses removeAssociation: (Globals associationAt: #Globals ).

System clusterBucket: behaviorBucket.
classes associationsDo: [ :each |
    each value _alias . "for debugging"
    each value clusterBehavior.
    ].

System clusterBucket: descriptionBucket.
classes associationsDo: [ :each | 
    each value clusterDescription.
    ] .
false
%


expectvalue true
send System _commitPrintingDiagnostics

