! $Id: fractio2.gs,v 1.3 2007-10-22 18:18:49 otisa Exp $
!   file  fractio2.gs

! Fraction asFloat rewritten for fix 36173
! method now must come after Float defined  because it has float literals
category: 'Converting'
method: Fraction
asFloat

"Returns an instance of Float that has the value of the receiver."
| nParts dParts mantiss exp |

numerator == nil ifTrue:[ ^ PlusSignalingNaN ] .
denominator == nil ifTrue:[ ^ PlusSignalingNaN ] .

"avoid loss of precision by handling mantissa and exponents separately"
nParts := numerator _floatParts .
dParts := denominator _floatParts .
mantiss := (nParts at:1) / (dParts at:1) .
exp := (nParts at:2) - (dParts at:2) .
^ mantiss * (2.0 raisedToInteger: exp )
%


